"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } async function _asyncNullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return await rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _base = require('@gregnr/postgres-meta/base');var _mcputils = require('@supabase/mcp-utils');var _zod = require('zod');var f="0.2.0";var _commontags = require('common-tags');function S(r,s=100){switch(r){case"api":return _commontags.stripIndent`
        select id, identifier, timestamp, event_message, request.method, request.path, response.status_code
        from edge_logs
        cross join unnest(metadata) as m
        cross join unnest(m.request) as request
        cross join unnest(m.response) as response
        order by timestamp desc
        limit ${s}
      `;case"branch-action":return _commontags.stripIndent`
          select workflow_run, workflow_run_logs.timestamp, id, event_message from workflow_run_logs
          order by timestamp desc
          limit ${s}
        `;case"postgres":return _commontags.stripIndent`
        select identifier, postgres_logs.timestamp, id, event_message, parsed.error_severity from postgres_logs
        cross join unnest(metadata) as m
        cross join unnest(m.parsed) as parsed
        order by timestamp desc
        limit ${s}
      `;case"edge-function":return _commontags.stripIndent`
        select * from function_logs
        order by timestamp desc
        limit ${s}
      `;case"auth":return _commontags.stripIndent`
        select id, auth_logs.timestamp, event_message, metadata.level, metadata.status, metadata.path, metadata.msg as msg, metadata.error from auth_logs
        cross join unnest(metadata) as metadata
        order by timestamp desc
        limit ${s}
      `;case"storage":return _commontags.stripIndent`
        select id, storage_logs.timestamp, event_message from storage_logs
        order by timestamp desc
        limit ${s}
      `;case"realtime":return _commontags.stripIndent`
        select id, realtime_logs.timestamp, event_message from realtime_logs
        order by timestamp desc
        limit ${s}
      `;default:throw new Error(`unsupported log service type: ${r}`)}}var _openapifetch = require('openapi-fetch'); var _openapifetch2 = _interopRequireDefault(_openapifetch);function _(r,s,n={}){return _openapifetch2.default.call(void 0, {baseUrl:r,headers:{"Content-Type":"application/json",Authorization:`Bearer ${s}`,...n}})}var v=_zod.z.object({message:_zod.z.string()});function i(r,s){if("error"in r){if(r.response.status===401)throw new Error("Unauthorized. Please provide a valid access token to the MCP server via the --access-token flag.");let{data:n}=v.safeParse(r.error);throw n?new Error(n.message):new Error(s)}}var O="ABCDEFGHIJKLMNOPQRSTUVWXYZ",N="abcdefghijklmnopqrstuvwxyz",U="0123456789",L="!@#$%^&*()_+~`|}{[]:;?><,./-=",w=({length:r=10,numbers:s=!1,symbols:n=!1,uppercase:d=!0,lowercase:g=!0}={})=>{let p="";if(d&&(p+=O),g&&(p+=N),s&&(p+=U),n&&(p+=L),p.length===0)throw new Error("at least one character set must be selected");let h=new Uint32Array(r);crypto.getRandomValues(h);let t="";for(let e=0;e<r;e++){let l=h[e]%p.length;t+=p.charAt(l)}return t};function j(r){return Object.fromEntries(r.split(`
`).map(s=>s.split(/=(.*)/)).filter(([s])=>s).map(([s,n])=>[s,_nullishCoalesce(n, () => (""))]))}var P=6371,G="https://www.cloudflare.com/cdn-cgi/trace",I={AF:{lat:33,lng:65},AX:{lat:60.116667,lng:19.9},AL:{lat:41,lng:20},DZ:{lat:28,lng:3},AS:{lat:-14.3333,lng:-170},AD:{lat:42.5,lng:1.6},AO:{lat:-12.5,lng:18.5},AI:{lat:18.25,lng:-63.1667},AQ:{lat:-90,lng:0},AG:{lat:17.05,lng:-61.8},AR:{lat:-34,lng:-64},AM:{lat:40,lng:45},AW:{lat:12.5,lng:-69.9667},AU:{lat:-27,lng:133},AT:{lat:47.3333,lng:13.3333},AZ:{lat:40.5,lng:47.5},BS:{lat:24.25,lng:-76},BH:{lat:26,lng:50.55},BD:{lat:24,lng:90},BB:{lat:13.1667,lng:-59.5333},BY:{lat:53,lng:28},BE:{lat:50.8333,lng:4},BZ:{lat:17.25,lng:-88.75},BJ:{lat:9.5,lng:2.25},BM:{lat:32.3333,lng:-64.75},BT:{lat:27.5,lng:90.5},BO:{lat:-17,lng:-65},BQ:{lat:12.183333,lng:-68.233333},BA:{lat:44,lng:18},BW:{lat:-22,lng:24},BV:{lat:-54.4333,lng:3.4},BR:{lat:-10,lng:-55},IO:{lat:-6,lng:71.5},BN:{lat:4.5,lng:114.6667},BG:{lat:43,lng:25},BF:{lat:13,lng:-2},MM:{lat:22,lng:98},BI:{lat:-3.5,lng:30},KH:{lat:13,lng:105},CM:{lat:6,lng:12},CA:{lat:60,lng:-95},CV:{lat:16,lng:-24},KY:{lat:19.5,lng:-80.5},CF:{lat:7,lng:21},TD:{lat:15,lng:19},CL:{lat:-30,lng:-71},CN:{lat:35,lng:105},CX:{lat:-10.5,lng:105.6667},CC:{lat:-12.5,lng:96.8333},CO:{lat:4,lng:-72},KM:{lat:-12.1667,lng:44.25},CD:{lat:0,lng:25},CG:{lat:-1,lng:15},CK:{lat:-21.2333,lng:-159.7667},CR:{lat:10,lng:-84},CI:{lat:8,lng:-5},HR:{lat:45.1667,lng:15.5},CU:{lat:21.5,lng:-80},CW:{lat:12.166667,lng:-68.966667},CY:{lat:35,lng:33},CZ:{lat:49.75,lng:15.5},DK:{lat:56,lng:10},DJ:{lat:11.5,lng:43},DM:{lat:15.4167,lng:-61.3333},DO:{lat:19,lng:-70.6667},EC:{lat:-2,lng:-77.5},EG:{lat:27,lng:30},SV:{lat:13.8333,lng:-88.9167},GQ:{lat:2,lng:10},ER:{lat:15,lng:39},EE:{lat:59,lng:26},ET:{lat:8,lng:38},FK:{lat:-51.75,lng:-59},FO:{lat:62,lng:-7},FJ:{lat:-18,lng:175},FI:{lat:64,lng:26},FR:{lat:46,lng:2},GF:{lat:4,lng:-53},PF:{lat:-15,lng:-140},TF:{lat:-43,lng:67},GA:{lat:-1,lng:11.75},GM:{lat:13.4667,lng:-16.5667},GE:{lat:42,lng:43.5},DE:{lat:51,lng:9},GH:{lat:8,lng:-2},GI:{lat:36.1833,lng:-5.3667},GR:{lat:39,lng:22},GL:{lat:72,lng:-40},GD:{lat:12.1167,lng:-61.6667},GP:{lat:16.25,lng:-61.5833},GU:{lat:13.4667,lng:144.7833},GT:{lat:15.5,lng:-90.25},GG:{lat:49.5,lng:-2.56},GW:{lat:12,lng:-15},GN:{lat:11,lng:-10},GY:{lat:5,lng:-59},HT:{lat:19,lng:-72.4167},HM:{lat:-53.1,lng:72.5167},VA:{lat:41.9,lng:12.45},HN:{lat:15,lng:-86.5},HK:{lat:22.25,lng:114.1667},HU:{lat:47,lng:20},IS:{lat:65,lng:-18},IN:{lat:20,lng:77},ID:{lat:-5,lng:120},IR:{lat:32,lng:53},IQ:{lat:33,lng:44},IE:{lat:53,lng:-8},IM:{lat:54.23,lng:-4.55},IL:{lat:31.5,lng:34.75},IT:{lat:42.8333,lng:12.8333},JM:{lat:18.25,lng:-77.5},JP:{lat:36,lng:138},JE:{lat:49.21,lng:-2.13},JO:{lat:31,lng:36},KZ:{lat:48,lng:68},KE:{lat:1,lng:38},KI:{lat:1.4167,lng:173},KP:{lat:40,lng:127},KR:{lat:37,lng:127.5},XK:{lat:42.583333,lng:21},KW:{lat:29.3375,lng:47.6581},KG:{lat:41,lng:75},LA:{lat:18,lng:105},LV:{lat:57,lng:25},LB:{lat:33.8333,lng:35.8333},LS:{lat:-29.5,lng:28.5},LR:{lat:6.5,lng:-9.5},LY:{lat:25,lng:17},LI:{lat:47.1667,lng:9.5333},LT:{lat:56,lng:24},LU:{lat:49.75,lng:6.1667},MO:{lat:22.1667,lng:113.55},MK:{lat:41.8333,lng:22},MG:{lat:-20,lng:47},MW:{lat:-13.5,lng:34},MY:{lat:2.5,lng:112.5},MV:{lat:3.25,lng:73},ML:{lat:17,lng:-4},MT:{lat:35.8333,lng:14.5833},MH:{lat:9,lng:168},MQ:{lat:14.6667,lng:-61},MR:{lat:20,lng:-12},MU:{lat:-20.2833,lng:57.55},YT:{lat:-12.8333,lng:45.1667},MX:{lat:23,lng:-102},FM:{lat:6.9167,lng:158.25},MD:{lat:47,lng:29},MC:{lat:43.7333,lng:7.4},MN:{lat:46,lng:105},ME:{lat:42,lng:19},MS:{lat:16.75,lng:-62.2},MA:{lat:32,lng:-5},MZ:{lat:-18.25,lng:35},NA:{lat:-22,lng:17},NR:{lat:-.5333,lng:166.9167},NP:{lat:28,lng:84},AN:{lat:12.25,lng:-68.75},NL:{lat:52.5,lng:5.75},NC:{lat:-21.5,lng:165.5},NZ:{lat:-41,lng:174},NI:{lat:13,lng:-85},NE:{lat:16,lng:8},NG:{lat:10,lng:8},NU:{lat:-19.0333,lng:-169.8667},NF:{lat:-29.0333,lng:167.95},MP:{lat:15.2,lng:145.75},NO:{lat:62,lng:10},OM:{lat:21,lng:57},PK:{lat:30,lng:70},PW:{lat:7.5,lng:134.5},PS:{lat:32,lng:35.25},PA:{lat:9,lng:-80},PG:{lat:-6,lng:147},PY:{lat:-23,lng:-58},PE:{lat:-10,lng:-76},PH:{lat:13,lng:122},PN:{lat:-24.7,lng:-127.4},PL:{lat:52,lng:20},PT:{lat:39.5,lng:-8},PR:{lat:18.25,lng:-66.5},QA:{lat:25.5,lng:51.25},RE:{lat:-21.1,lng:55.6},RO:{lat:46,lng:25},RU:{lat:60,lng:100},RW:{lat:-2,lng:30},BL:{lat:17.897728,lng:-62.834244},SH:{lat:-15.9333,lng:-5.7},KN:{lat:17.3333,lng:-62.75},LC:{lat:13.8833,lng:-61.1333},MF:{lat:18.075278,lng:-63.06},PM:{lat:46.8333,lng:-56.3333},VC:{lat:13.25,lng:-61.2},WS:{lat:-13.5833,lng:-172.3333},SM:{lat:43.7667,lng:12.4167},ST:{lat:1,lng:7},SA:{lat:25,lng:45},SN:{lat:14,lng:-14},RS:{lat:44,lng:21},SC:{lat:-4.5833,lng:55.6667},SL:{lat:8.5,lng:-11.5},SG:{lat:1.3667,lng:103.8},SX:{lat:18.033333,lng:-63.05},SK:{lat:48.6667,lng:19.5},SI:{lat:46,lng:15},SB:{lat:-8,lng:159},SO:{lat:10,lng:49},ZA:{lat:-29,lng:24},GS:{lat:-54.5,lng:-37},SS:{lat:8,lng:30},ES:{lat:40,lng:-4},LK:{lat:7,lng:81},SD:{lat:15,lng:30},SR:{lat:4,lng:-56},SJ:{lat:78,lng:20},SZ:{lat:-26.5,lng:31.5},SE:{lat:62,lng:15},CH:{lat:47,lng:8},SY:{lat:35,lng:38},TW:{lat:23.5,lng:121},TJ:{lat:39,lng:71},TZ:{lat:-6,lng:35},TH:{lat:15,lng:100},TL:{lat:-8.55,lng:125.5167},TG:{lat:8,lng:1.1667},TK:{lat:-9,lng:-172},TO:{lat:-20,lng:-175},TT:{lat:11,lng:-61},TN:{lat:34,lng:9},TR:{lat:39,lng:35},TM:{lat:40,lng:60},TC:{lat:21.75,lng:-71.5833},TV:{lat:-8,lng:178},UG:{lat:1,lng:32},UA:{lat:49,lng:32},AE:{lat:24,lng:54},GB:{lat:54,lng:-2},UM:{lat:19.2833,lng:166.6},US:{lat:38,lng:-97},UY:{lat:-33,lng:-56},UZ:{lat:41,lng:64},VU:{lat:-16,lng:167},VE:{lat:8,lng:-66},VN:{lat:16,lng:106},VG:{lat:18.5,lng:-64.5},VI:{lat:18.3333,lng:-64.8333},WF:{lat:-13.3,lng:-176.2},EH:{lat:24.5,lng:-13},YE:{lat:15,lng:48},ZM:{lat:-15,lng:30},ZW:{lat:-20,lng:30}},b={WEST_US:{code:"us-west-1",displayName:"West US (North California)",location:{lat:37.774929,lng:-122.419418}},EAST_US:{code:"us-east-1",displayName:"East US (North Virginia)",location:{lat:37.926868,lng:-78.024902}},EAST_US_2:{code:"us-east-2",displayName:"East US (Ohio)",location:{lat:39.9612,lng:-82.9988}},CENTRAL_CANADA:{code:"ca-central-1",displayName:"Canada (Central)",location:{lat:56.130367,lng:-106.346771}},WEST_EU:{code:"eu-west-1",displayName:"West EU (Ireland)",location:{lat:53.3498,lng:-6.2603}},WEST_EU_2:{code:"eu-west-2",displayName:"West Europe (London)",location:{lat:51.507351,lng:-.127758}},WEST_EU_3:{code:"eu-west-3",displayName:"West EU (Paris)",location:{lat:2.352222,lng:48.856613}},CENTRAL_EU:{code:"eu-central-1",displayName:"Central EU (Frankfurt)",location:{lat:50.110924,lng:8.682127}},CENTRAL_EU_2:{code:"eu-central-2",displayName:"Central Europe (Zurich)",location:{lat:47.3744489,lng:8.5410422}},NORTH_EU:{code:"eu-north-1",displayName:"North EU (Stockholm)",location:{lat:59.3251172,lng:18.0710935}},SOUTH_ASIA:{code:"ap-south-1",displayName:"South Asia (Mumbai)",location:{lat:18.9733536,lng:72.8281049}},SOUTHEAST_ASIA:{code:"ap-southeast-1",displayName:"Southeast Asia (Singapore)",location:{lat:1.357107,lng:103.8194992}},NORTHEAST_ASIA:{code:"ap-northeast-1",displayName:"Northeast Asia (Tokyo)",location:{lat:35.6895,lng:139.6917}},NORTHEAST_ASIA_2:{code:"ap-northeast-2",displayName:"Northeast Asia (Seoul)",location:{lat:37.5665,lng:126.978}},OCEANIA:{code:"ap-southeast-2",displayName:"Oceania (Sydney)",location:{lat:-33.8688,lng:151.2093}},SOUTH_AMERICA:{code:"sa-east-1",displayName:"South America (S\xE3o Paulo)",location:{lat:-1.2043218,lng:-47.1583944}}},A=Object.values(b).map(r=>r.code);function E(r){let n=Object.entries(b).map(([g,p])=>[g,F(r,p.location)]).reduce((g,p)=>g===void 0||p[1]<g[1]?p:g,void 0);if(!n)throw new Error("no closest region found");let[d]=n;return b[d]}async function x(){let s=await(await fetch(G)).text(),d=j(s).loc;if(!d)throw new Error("location not found");return d}function M(r){let s=I[r];if(!s)throw new Error(`unknown location code: ${r}`);return s}function F(r,s){let n=m(s.lat-r.lat),d=m(s.lng-r.lng),g=Math.sin(n/2)*Math.sin(n/2)+Math.cos(m(r.lat))*Math.cos(m(s.lat))*Math.sin(d/2)*Math.sin(d/2),p=2*Math.atan2(Math.sqrt(g),Math.sqrt(1-g));return P*p}function m(r){return r*(Math.PI/180)}function oe(r){let s=_nullishCoalesce(r.platform.apiUrl, () => ("https://api.supabase.com")),n;async function d(t,e){let l=await n.POST("/v1/projects/{ref}/database/query",{params:{path:{ref:t}},body:{query:e}});return i(l,"Failed to execute SQL query"),l.data}function g(t){return new (0, _base.PostgresMetaBase)({query:async e=>{try{let l=await d(t,e);return _base.wrapResult.call(void 0, l)}catch(l){return _base.wrapError.call(void 0, l,e)}},end:async()=>{}})}async function p(){return E(M(await x())).code}return _mcputils.createMcpServer.call(void 0, {name:"supabase",version:f,onInitialize(t){n=_(s,r.platform.accessToken,{"User-Agent":`supabase-mcp/${f} (${t.name}/${t.version})`})},tools:{list_projects:_mcputils.tool.call(void 0, {description:"Lists all Supabase projects for the user.",parameters:_zod.z.object({}),execute:async()=>{let t=await n.GET("/v1/projects");return i(t,"Failed to fetch projects"),t.data}}),get_project:_mcputils.tool.call(void 0, {description:"Gets details for a Supabase project.",parameters:_zod.z.object({id:_zod.z.string().describe("The project ID")}),execute:async({id:t})=>{let e=await n.GET("/v1/projects/{ref}",{params:{path:{ref:t}}});return i(e,"Failed to fetch project"),e.data}}),create_project:_mcputils.tool.call(void 0, {description:"Creates a new Supabase project. Always ask the user which organization to create the project in. The project can take a few minutes to initialize - use `getProject` to check the status.",parameters:_zod.z.object({name:_zod.z.string().describe("The name of the project"),region:_zod.z.optional(_zod.z.enum(A).describe("The region to create the project in. Defaults to the closest region.")),organization_id:_zod.z.string()}),execute:async({name:t,region:e,organization_id:l})=>{let c=await n.POST("/v1/projects",{body:{name:t,region:await _asyncNullishCoalesce(e, async () => (await p())),organization_id:l,db_pass:w({length:16,numbers:!0,uppercase:!0,lowercase:!0})}});return i(c,"Failed to create project"),c.data}}),pause_project:_mcputils.tool.call(void 0, {description:"Pauses a Supabase project.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.POST("/v1/projects/{ref}/pause",{params:{path:{ref:t}}});i(e,"Failed to pause project")}}),restore_project:_mcputils.tool.call(void 0, {description:"Restores a Supabase project.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.POST("/v1/projects/{ref}/restore",{params:{path:{ref:t}},body:{}});i(e,"Failed to restore project")}}),list_organizations:_mcputils.tool.call(void 0, {description:"Lists all organizations that the user is a member of.",parameters:_zod.z.object({}),execute:async()=>{let t=await n.GET("/v1/organizations");return i(t,"Failed to fetch organizations"),t.data}}),get_organization:_mcputils.tool.call(void 0, {description:"Gets details for an organization. Includes subscription plan.",parameters:_zod.z.object({id:_zod.z.string().describe("The organization ID")}),execute:async({id:t})=>{let e=await n.GET("/v1/organizations/{slug}",{params:{path:{slug:t}}});return i(e,"Failed to fetch organization"),e.data}}),list_tables:_mcputils.tool.call(void 0, {description:"Lists all tables in a schema.",parameters:_zod.z.object({project_id:_zod.z.string(),schemas:_zod.z.optional(_zod.z.array(_zod.z.string())).describe("Optional list of schemas to include. Defaults to all schemas.")}),execute:async({project_id:t,schemas:e})=>{let l=g(t),{data:c,error:y}=await l.tables.list({includedSchemas:e});if(y)throw new Error(`Error fetching tables: ${y.message}`);return c}}),list_extensions:_mcputils.tool.call(void 0, {description:"Lists all extensions in the database.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=g(t),{data:l,error:c}=await e.extensions.list();if(c)throw new Error(`Error fetching extensions: ${c.message}`);return l}}),list_migrations:_mcputils.tool.call(void 0, {description:"Lists all migrations in the database.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.GET("/v1/projects/{ref}/database/migrations",{params:{path:{ref:t}}});return i(e,"Failed to fetch migrations"),e.data}}),apply_migration:_mcputils.tool.call(void 0, {description:"Applies a migration to the database. Use this when executing DDL operations.",parameters:_zod.z.object({project_id:_zod.z.string(),name:_zod.z.string().describe("The name of the migration in snake_case"),query:_zod.z.string().describe("The SQL query to apply")}),execute:async({project_id:t,name:e,query:l})=>{let c=await n.POST("/v1/projects/{ref}/database/migrations",{params:{path:{ref:t}},body:{name:e,query:l}});return i(c,"Failed to apply migration"),c.data}}),execute_sql:_mcputils.tool.call(void 0, {description:"Executes raw SQL in the Postgres database. Use `applyMigration` instead for DDL operations.",parameters:_zod.z.object({project_id:_zod.z.string(),query:_zod.z.string().describe("The SQL query to execute")}),execute:async({query:t,project_id:e})=>await d(e,t)}),get_logs:_mcputils.tool.call(void 0, {description:"Gets logs for a Supabase project by service type. Use this to help debug problems with your app. This will only return logs within the last minute. If the logs you are looking for are older than 1 minute, re-run your test to reproduce them.",parameters:_zod.z.object({project_id:_zod.z.string(),service:_zod.z.enum(["api","branch-action","postgres","edge-function","auth","storage","realtime"]).describe("The service to fetch logs for")}),execute:async({project_id:t,service:e})=>{let l=e==="branch-action"?new Date(Date.now()-3e5):void 0,c=await n.GET("/v1/projects/{ref}/analytics/endpoints/logs.all",{params:{path:{ref:t},query:{iso_timestamp_start:_optionalChain([l, 'optionalAccess', _2 => _2.toISOString, 'call', _3 => _3()]),sql:S(e)}}});return i(c,"Failed to fetch logs"),c.data}}),get_project_url:_mcputils.tool.call(void 0, {description:"Gets the API URL for a project.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>`https://${t}.supabase.co`}),get_anon_key:_mcputils.tool.call(void 0, {description:"Gets the anonymous API key for a project.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.GET("/v1/projects/{ref}/api-keys",{params:{path:{ref:t},query:{reveal:!1}}});i(e,"Failed to fetch API keys");let l=_optionalChain([e, 'access', _4 => _4.data, 'optionalAccess', _5 => _5.find, 'call', _6 => _6(c=>c.name==="anon")]);if(!l)throw new Error("Anonymous key not found");return l.api_key}}),generate_typescript_types:_mcputils.tool.call(void 0, {description:"Generates TypeScript types for a project.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.GET("/v1/projects/{ref}/types/typescript",{params:{path:{ref:t}}});return i(e,"Failed to fetch TypeScript types"),e.data}}),create_branch:_mcputils.tool.call(void 0, {description:"Creates a development branch on a Supabase project. This will apply all migrations from the main project to a fresh branch database. Note that production data will not carry over. The branch will get its own project_id via the resulting project_ref. Use this ID to execute queries and migrations on the branch.",parameters:_zod.z.object({project_id:_zod.z.string(),name:_zod.z.string().default("develop").describe("Name of the branch to create")}),execute:async({project_id:t,name:e})=>{let l=await n.POST("/v1/projects/{ref}/branches",{params:{path:{ref:t}},body:{branch_name:e}});if(i(l,"Failed to create branch"),l.data.is_default){await n.PATCH("/v1/branches/{branch_id}",{params:{path:{branch_id:l.data.id}},body:{branch_name:"main"}});let c=await n.POST("/v1/projects/{ref}/branches",{params:{path:{ref:t}},body:{branch_name:e}});return i(c,"Failed to create branch"),c.data}return l.data}}),list_branches:_mcputils.tool.call(void 0, {description:"Lists all development branches of a Supabase project. This will return branch details including status which you can use to check when operations like merge/rebase/reset complete.",parameters:_zod.z.object({project_id:_zod.z.string()}),execute:async({project_id:t})=>{let e=await n.GET("/v1/projects/{ref}/branches",{params:{path:{ref:t}}});return e.response.status===422?[]:(i(e,"Failed to list branches"),e.data)}}),delete_branch:_mcputils.tool.call(void 0, {description:"Deletes a development branch.",parameters:_zod.z.object({branch_id:_zod.z.string()}),execute:async({branch_id:t})=>{let e=await n.DELETE("/v1/branches/{branch_id}",{params:{path:{branch_id:t}}});return i(e,"Failed to delete branch"),e.data}}),merge_branch:_mcputils.tool.call(void 0, {description:"Merges migrations and edge functions from a development branch to production.",parameters:_zod.z.object({branch_id:_zod.z.string()}),execute:async({branch_id:t})=>{let e=await n.POST("/v1/branches/{branch_id}/merge",{params:{path:{branch_id:t}},body:{}});return i(e,"Failed to merge branch"),e.data}}),reset_branch:_mcputils.tool.call(void 0, {description:"Resets migrations of a development branch. Any untracked data or schema changes will be lost.",parameters:_zod.z.object({branch_id:_zod.z.string(),migration_version:_zod.z.string().optional().describe("Reset your development branch to a specific migration version.")}),execute:async({branch_id:t,migration_version:e})=>{let l=await n.POST("/v1/branches/{branch_id}/reset",{params:{path:{branch_id:t}},body:{migration_version:e}});return i(l,"Failed to reset branch"),l.data}}),rebase_branch:_mcputils.tool.call(void 0, {description:"Rebases a development branch on production. This will effectively run any newer migrations from production onto this branch to help handle migration drift.",parameters:_zod.z.object({branch_id:_zod.z.string()}),execute:async({branch_id:t})=>{let e=await n.POST("/v1/branches/{branch_id}/push",{params:{path:{branch_id:t}},body:{}});return i(e,"Failed to rebase branch"),e.data}})}})}exports.a = oe;
//# sourceMappingURL=chunk-UKI5QE7W.cjs.map